<?php
/**
 * Apptha
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.apptha.com/LICENSE.txt
 *
 * ==============================================================
 *                 MAGENTO EDITION USAGE NOTICE
 * ==============================================================
 * This package designed for Magento COMMUNITY edition
 * Apptha does not guarantee correct work of this extension
 * on any other Magento edition except Magento COMMUNITY edition.
 * Apptha does not provide extension support in case of
 * incorrect edition usage.
 * ==============================================================
 *
 * @category    Apptha
 * @package     Apptha_Marketplace
 * @version     1.9.0
 * @author      Apptha Team <developers@contus.in>
 * @copyright   Copyright (c) 2015 Apptha. (http://www.apptha.com)
 * @license     http://www.apptha.com/LICENSE.txt
 *
 */
/**
 * Payment methods management
 * This class is used for managing payment methods of one step checkout
 */
class Apptha_Onestepcheckout_Block_Onestep_Payment_Methods extends Mage_Checkout_Block_Onepage_Payment_Methods {
    /**
     * get checkout session quote value
     */
    public function getQuote() {
        return Mage::getSingleton ( 'checkout/session' )->getQuote ();
    }
    
    /**
     * Check and prepare payment method model
     *
     * @return bool
     */
    protected function _canUseMethod($method) {
        if (! $method || ! $method->canUseCheckout ()) {
            return false;
        }
        return parent::_canUseMethod ( $method );
    }
    
    /**
     * Retrieve code of current payment method
     *
     * @return mixed
     */
    public function getSelectedMethodCode() {
        if ($method = $this->getQuote ()->getPayment ()->getMethod ()) {
            return $method;
        }
        return false;
    }
    
    /**
     * Payment method form html getter
     *
     * @param Mage_Payment_Model_Method_Abstract $method            
     */
    public function getPaymentMethodFormHtml(Mage_Payment_Model_Method_Abstract $method) {
        return $this->getChildHtml ( 'payment.method.' . $method->getCode () );
    }
    
    /**
     * Return method title for payment selection page
     *
     * @param Mage_Payment_Model_Method_Abstract $method            
     */
    public function getMethodTitle(Mage_Payment_Model_Method_Abstract $method) {
        $form = $this->getChild ( 'payment.method.' . $method->getCode () );
        if ($form && $form->hasMethodTitle ()) {
            return $form->getMethodTitle ();
        }
        return $method->getTitle ();
    }
    
    /**
     * Payment method additional label part getter
     *
     * @param Mage_Payment_Model_Method_Abstract $method            
     */
    public function getMethodLabelAfterHtml(Mage_Payment_Model_Method_Abstract $method) {
        if ($form = $this->getChild ( 'payment.method.' . $method->getCode () )) {
            return $form->getMethodLabelAfterHtml ();
        }
    }
}
